
use AdventureWorksDW2008Big
go

-- set number of rows to 123 million
UPDATE STATISTICS [dbo].[FactInternetSales]
WITH ROWCOUNT = 123000000,PAGECOUNT = 10000000
go

-- memory grant info
-- <MemoryGrantInfo SerialRequiredMemory="2560" SerialDesiredMemory="8040" RequiredMemory="11488" 
--  DesiredMemory="16992" RequestedMemory="16992" GrantWaitTime="0" GrantedMemory="16992" MaxUsedMemory="5008" />
SELECT     p.ProductLine,
           SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
     f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine;


-- notice memory grant less
-- <MemoryGrantInfo SerialRequiredMemory="2560" SerialDesiredMemory="4936" RequiredMemory="2560" 
--  DesiredMemory="4936" RequestedMemory="4936" GrantWaitTime="0" GrantedMemory="4936" MaxUsedMemory="1736" />
-- non-parallel plan reason
SELECT     p.ProductLine,
           SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
     f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine
OPTION (MAXDOP 1);

-- other diagnostics
select * from sys.dm_exec_query_memory_grants 

-- retrived from cache 
DBCC FREEPROCCACHE
GO

-- retreived from cache - true?
-- it just means that object will be recompiled on the next run and retrieved from cache
SELECT     p.ProductLine,
           SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
     f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine;

-- retreived from cache - false
SELECT     p.ProductLine,
           SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
     f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine
OPTION (RECOMPILE)

EXEC sp_configure 'show advanced options',1; 
RECONFIGURE;  
EXEC sp_configure 'optimize for ad hoc workloads',1; 
RECONFIGURE;
GO

-- retreived from cache - false
SELECT     p.ProductLine,
           SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
     f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine;

-- 2nd time - retreived from cache - true
SELECT     p.ProductLine,
           SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
     f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine;

-- set it back
EXEC sp_configure 'show advanced options',1; 
RECONFIGURE;  
EXEC sp_configure 'optimize for ad hoc workloads',0; 
RECONFIGURE;
GO

-- thread usage

SELECT p.ProductLine,
SUM(f.SalesAmount) AS TotalSalesAmount
FROM [dbo].[FactInternetSales] AS f
INNER JOIN [dbo].[DimProduct] AS p ON
f.ProductKey = p.ProductKey
GROUP BY p.ProductLine
ORDER BY p.ProductLine;

